%This is a program which takes as input a braid, and generates a matrix
%which has as its ith row the braid representation of the ith disconnected
%component.  For example, the input [1 3 1 3 1 3] is actually the braid of
%two disjoint trefoils [1 1 1] and [3 3 3].

function f=components(x)

%We sort the absolute values of x so that we can see which strands are
%missing from the braid representation.  For each missing strand we will
%get another disconnected braid component.
sorted=unique(abs(x));

missing=[];
difference=[];
difference(1)=sorted(1)-1;
for i=2:length(sorted)
    difference(i)=sorted(i) - sorted(i-1);
end

%We find which strands are missing from the braid representation.
q=0;
for i=1:length(difference)
        for k=1:difference(i)-1
            q=q+1;
            missing(q)= sorted(i-1) + k;
        end
end

%We make a matrix where the ith row is the braid representation of the ith
%disconnected component.

component=[];
if isempty(missing)==1
    f=x;

else
for i=1:length(missing)+1
    k=0;
    for j=1:length(x)
        if (i==1)
            if (abs(x(j))< missing(i))
                k=k+1;
                component(i,k)=x(j); 
            end
        elseif (i>length(missing))
            if missing(i-1) < abs(x(j))
                k=k+1;
                component(i,k)=x(j);    
            end
        else
            if (missing(i-1) < abs(x(j)))&&(abs(x(j)) < missing(i))
                k=k+1;
                component(i,k)=x(j);
            end
        end
    end
end

f=component;
end